; mumbo-jumbo, copied randomly on demand from my BankSDK

NO_OBJVECTORS	equ 1

;----------[ normal includes ... ]---------\
.686
.model flat,stdcall
.mmx
option casemap :none
option proc:private

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\kernel32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
;------------------------------------------/

UseAll textequ <uses eax ebx ecx edx esi edi>
UseMost textequ <uses ebx ecx edx esi edi>



m2m MACRO M1, M2
        push M2
        pop  M1
ENDM	
return MACRO Var1
	mov eax,Var1
	ret
ENDM


malloc MACRO How:REQ
	invoke malloc_func,How
	exitm <eax>
ENDM

realloc MACRO What:REQ,How:REQ
	invoke realloc_func,What,How
	exitm <eax>
ENDM
	
free MACRO What:REQ
	invoke free_func,What
ENDM
T macro Text:VARARG
        local szText
        .data
        szText byte Text, 0
        .code
        exitm <offset szText>        
endm


pushi macro Whats:VARARG
	local txt1
	for txt1,<Whats>
		push txt1
	endm
endm
popi macro arglist:VARARG
	local txt1
	LOCAL txt, arg
	txt TEXTEQU <>
	FOR arg, <arglist>
		txt CATSTR <arg>, <!,>, txt
	endm
	txt SUBSTR  txt, 1, @SizeStr( %txt ) - 1
	%for txt1,<txt>
		pop txt1
	endm
endm

poppi textequ <popi>


;====================================================================================================

HEAP_ZERO_MEMORY equ 00000008h      

.data
	HEAP1 dd 0
.code

HeapCreate proto :DWORD,:DWORD,:DWORD
HeapAlloc proto :DWORD,:DWORD,:DWORD
HeapFree proto :DWORD,:DWORD,:DWORD
HeapSize proto :DWORD,:DWORD,:DWORD
HeapReAlloc proto :DWORD,:DWORD,:DWORD,:DWORD
memmove  proto Where:DWORD,From:DWORD,Len:DWORD

malloc_func proc PRIVATE uses ebx ecx edx esi edi How
	invoke HeapAlloc,HEAP1,HEAP_ZERO_MEMORY,How	
	ret
malloc_func endp
	
free_func proc PRIVATE uses eax ebx ecx edx esi edi What
	invoke HeapFree,HEAP1,0,What
	ret
free_func endp

realloc_func proc PRIVATE uses ebx ecx edx esi edi What,How
	.if !What
		.if How
			invoke HeapAlloc,HEAP1,HEAP_ZERO_MEMORY,How
		.else
			xor eax,eax
		.endif
	.else
		.if How
			invoke HeapReAlloc,HEAP1,HEAP_ZERO_MEMORY,What,How
		.else
			invoke HeapFree,HEAP1,0,What
			xor eax,eax
		.endif
	.endif
	ret
realloc_func endp

memmove proc PRIVATE uses ecx esi edi Where,From,Len
	cld
	mov esi,From
	mov edi,Where
	mov ecx,Len
	shr ecx,2
	rep movsd
	mov ecx,Len
	and ecx,3
	rep movsb
	ret
memmove endp
memclone proc PRIVATE uses ebx ecx edx esi edi pSrc,dwSize
	invoke HeapAlloc,HEAP1,0,dwSize
	.if eax
		invoke memmove,eax,pSrc,dwSize
	.endif
	ret
memclone endp







;=====[[ Unpack >>===\

MAX_BITS = 14                            ;Maximum amount of bits in the
					 ;output symbol. _Size_, _time_
					 ;and _compression_ is directly
                                         ;dependant from this number
                                         ;
BITS_DEPENDED_BUFF_SIZE = (1 shl MAX_BITS) ;Size of the buffer for dictionary
                                         ;
COMPR_DICT_ITEM_SIZE   = (2+2+1)         ;sizeof(TableItem)
DECOMPR_DICT_ITEM_SIZE = (2+1)           ;sizeof(same but for LZD)
                                         ;
COMPR_BUFFER_SIZE   = (COMPR_DICT_ITEM_SIZE*BITS_DEPENDED_BUFF_SIZE)   ;
                                         ;Size of the compression buffer
                                         ;
DECOMPR_BUFFER_SIZE = (DECOMPR_DICT_ITEM_SIZE*BITS_DEPENDED_BUFF_SIZE) ;
                                         ;Size of the decompression buffer
                                         ;




VarFrame        struc                      ;
vf_Const01FF    dw ?                       ;Mask (perverted)
vf_Const03FF    dw ?                       ;Other one
vf_Const07FF    dw ?                       ;Third
vf_Const0FFF    dw ?                       ;Last
                                           ;
vf_Sym1         dw ?                       ;Symbols
vf_Sym2         dw ?                       ;
vf_Sym3         dw ?                       ;
                                           ;
vf_FreeSym      dw ?                       ;Free symbol
vf_CharCount    dw ?                       ;Character count
vf_DictSize     dw ?                       ;Dictionary size
vf_BitSize      dw ?                       ;Bits in char
vf_SimpleChar   db ?                       ;Character
vf_CharToLink   db ?                       ;explains itself
                                           ;
vf_InBufRelPos  dw ?                       ;Position in the input buffer
field_1A        dw ?                       ;
vf_OutBufPos    dd ?                       ;Position in the output buffer
field_20        dw ?                       ; Ultrano:2 bytes of return address
field_22        dw ?                       ; Ultrano:2 more bytes of return address
                                           ;Parameters
vf_InBuf        dd ?                       ;char *inbuf
vf_OutBuf       dd ?                       ;char *outbuf
vf_SuxxSize     dd ?                       ;char *size (not used) ; Ultrano: we never look how big the buffer is
vf_Malloced     dd ?                       ;char *buf (dictionary)
VarFrame        ends                       ;
                                           ;
;=============================================================================
;Main subroutine
;=============================================================================
lz_decompress   proc near                  ;
                sub     eax, eax           ; now eax=0
                push    eax                ; vf_OutBufPos=0
                push    eax                ; vf_InBufRelPos=0
                push    9                  ; vf_CharToLink=0, vf_SimpleChar=0,vf_BitSize=9
                push    2000000h           ; vf_DictSize=512, vf_CharCount=0
                push    1020000h           ; vf_freeSym=0x102,vf_Sym3=0
                push    eax                ; vf_Sym1=0,vf_Sym2=0
                push    0FFF07FFh          ;Perverted masks. vf_Const0FFF=0xFFF, vf_Const07FF=0x7FF
                push    3FF01FFh           ;vf_Const03FF=0x3FF,vf_Const01FF=0x1FF
                mov     ebp, esp           ; ebp - address to start of structure!
                                           ;
get_next_sym:                              ;
                call    Get_Sym            ;Get symbol
                cmp     ax, 101h           ; 101h - end of data
                jz      lzd_exit           ;
                cmp     ax, 100h           ; 100h - dictionary reset
                jnz     short other_syms   ;
                                           ;
                call    lzd_init           ;Reset
                                           ;
                call    Get_Sym            ;
                mov     [ebp+VarFrame.vf_Sym1], ax        ;
                mov     [ebp+VarFrame.vf_Sym2], ax        ;
                mov     [ebp+VarFrame.vf_CharToLink], al  ;
                mov     [ebp+VarFrame.vf_SimpleChar], al  ;
                call    Save_Char          ;First symbol is always simple
                jmp     short get_next_sym ;
; 
                                           ;
other_syms:                                ;
                mov     [ebp+VarFrame.vf_Sym1], ax      ;
                mov     [ebp+VarFrame.vf_Sym3], ax      ;
                cmp     ax, [ebp+VarFrame.vf_FreeSym]   ;Symbol is already in 
                jl      short already_in_dict           ;dictionary?
                                                        ;
                movzx   eax, [ebp+VarFrame.vf_Sym2]     ;
                mov     [ebp+VarFrame.vf_Sym1], ax      ;
                movzx   eax, [ebp+VarFrame.vf_SimpleChar]
                push    eax                             ;Leave it in stack
                inc     [ebp+VarFrame.vf_CharCount]     ;
                                                        ;
already_in_dict:                                        ;
                cmp     [ebp+VarFrame.vf_Sym1], 0FFh    ;
                jle     short one_time_again            ;
;                                                       ;
                movzx   ebx, [ebp+VarFrame.vf_Sym1]     ;
                call    _Calc_Sym_Pos                   ;
                mov     al, [ebx+2]                     ;
                push    eax                             ;Create chain in stack
                inc     [ebp+VarFrame.vf_CharCount]     ;
                movzx   eax, word ptr [ebx]             ;
                mov     [ebp+VarFrame.vf_Sym1], ax      ;
                jmp     short already_in_dict           ;
; 
                                                        ;
one_time_again:                                         ;
                movzx   eax, [ebp+VarFrame.vf_Sym1]        ;
                mov     [ebp+VarFrame.vf_SimpleChar], al   ;
                mov     [ebp+VarFrame.vf_CharToLink], al   ;
                push    eax                                ;
                inc     [ebp+VarFrame.vf_CharCount]        ;
                movzx   ecx, [ebp+VarFrame.vf_CharCount]   ;
                jcxz    no_chars                           ;
                                                           ;
save_from_stack:                                           ;Write chain from stack
                pop     eax                                ;
                call    Save_Char                          ;into output stream
                loop    save_from_stack                    ;
                                                           ;
no_chars:                                                  ;
                mov     [ebp+VarFrame.vf_CharCount], cx    ;
                                                           ;
                call    Add_Chain                          ;
                movzx   eax, [ebp+VarFrame.vf_Sym3]        ;
                mov     [ebp+VarFrame.vf_Sym2], ax         ;
                movzx   ebx, [ebp+VarFrame.vf_FreeSym]     ;
;                                                          ;
                cmp     bx, [ebp+VarFrame.vf_DictSize]     ;
                jl      get_next_sym                       ;
;                                                          ;
;-------->replaced<-----------------                        ;
;                cmp     [ebp+VarFrame.vf_BitSize], 0Ch     ;
                cmp     [ebp+VarFrame.vf_BitSize], MAX_BITS ;Check amount of bits
;-------->end<---------------------                        ;
                jz      get_next_sym                       ;
                                                           ;
                inc     [ebp+VarFrame.vf_BitSize]          ;Increase it
                shl     [ebp+VarFrame.vf_DictSize], 1      ;And dictionary size
                jmp     get_next_sym                       ;
; 
                                                           ;
lzd_exit:                                                  ;
                xchg    eax, edi                           ;EAX = end-start = size
                sub     eax, [ebp+VarFrame.vf_OutBuf]      ;
                add     esp, 20h                           ;
                retn    10h                                ;
lz_decompress   endp                                       ;
                                                           ;
;-----------------------------------------------------------------------------
;Calculate address of dictionary element from symbol nubmer
;-----------------------------------------------------------------------------
_Calc_Sym_Pos   proc near                                  ;
                lea     ebx, [ebx+ebx*2]                   ;EBX *= 3
                add     ebx, [ebp+VarFrame.vf_Malloced]    ;
                retn                                       ;
_Calc_Sym_Pos   endp                                       ;
                                                           ;
;-----------------------------------------------------------------------------
;Read symbol of variable size from the input stream
;-----------------------------------------------------------------------------
Get_Sym         proc near                                 ;
                movzx   eax, [ebp+VarFrame.vf_BitSize]    ; eax = vf_BitSize
                add     eax, dword ptr [ebp+VarFrame.vf_InBufRelPos] ;eax+=
                xchg    eax, dword ptr [ebp+VarFrame.vf_InBufRelPos]
                mov     ecx, 8                            ;
                sub     edx, edx                          ;
                div     ecx                               ; /8 (bits per byte)
                add     eax, [ebp+VarFrame.vf_InBuf]      ;
                xchg    eax, esi                          ;
                lodsw                                     ;Load 3 bytes
                movzx   ebx, ax                           ;
                lodsb                                     ;
                movzx   ecx, dx                           ;
                jcxz    getsym_exit                       ;
                                                          ;Select what we need
select_bits:                                              ;
                shr     al, 1                             ;
                rcr     bx, 1                             ;
                loop    select_bits                       ;
                                                          ;
getsym_exit:                                              ;
                movzx   eax, bx                           ;
                movzx   ebx, [ebp+VarFrame.vf_BitSize]    ;
                                                          ;
;------------>replaced<---------------------------------  ;
;                sub     ebx, 9                           ;
;                and     ax, [ebp+ebx*2+VarFrame.vf_Const01FF]
                                                          ;
                mov     cl, bl                            ;
                xor     ebx, ebx                          ;
                inc     ebx                               ;
                shl     bx, cl                            ;
                dec     bx                                ;
                and     ax, bx                            ;
                                                          ;
;------------>end<--------------------------------------  ;
                                                          ;
                retn                                      ;
Get_Sym         endp                                      ;
                                                          ;
;-----------------------------------------------------------------------------
;Dictionary reset
;-----------------------------------------------------------------------------
lzd_init        proc near                                 ;
                mov     [ebp+VarFrame.vf_BitSize], 9      ;Size in bits
                mov     [ebp+VarFrame.vf_DictSize], 200h  ;Dictionary size
                mov     [ebp+VarFrame.vf_FreeSym], 102h   ;First free symbol
                retn                                      ;
lzd_init        endp                                      ;
                                                          ;
;-----------------------------------------------------------------------------
;Write char into output stream
;-----------------------------------------------------------------------------
Save_Char       proc near                                 ;
                mov     edi, [ebp+VarFrame.vf_OutBufPos]  ;
                add     edi, [ebp+VarFrame.vf_OutBuf]     ;
                stosb                                     ;
                inc     [ebp+VarFrame.vf_OutBufPos]       ;
                retn                                      ;
Save_Char       endp                                      ;
                                                          ;
;-----------------------------------------------------------------------------
;Write links into the dictionary
;-----------------------------------------------------------------------------
Add_Chain       proc near                                 ;
                movzx   ebx, [ebp+VarFrame.vf_FreeSym]    ;
                call    _Calc_Sym_Pos                     ;
                movzx   eax, [ebp+VarFrame.vf_CharToLink] ;
                mov     [ebx+2], al                       ;
                movzx   eax, [ebp+VarFrame.vf_Sym2]       ;
                mov     [ebx], ax                         ;
                inc     [ebp+VarFrame.vf_FreeSym]         ;
                retn                                      ;
Add_Chain       endp                                      ;
                                                          ;

unpack proc uses ebx ecx edx esi edi UnpackWhat,UnpackWhere,PackedSize
	local dictionary
	.if !PackedSize
		xor eax,eax
		ret
	.endif
	invoke malloc_func,COMPR_BUFFER_SIZE
	mov dictionary,eax
	push ebp
	pushi dictionary,PackedSize,UnpackWhere,UnpackWhat
	call lz_decompress
	pop ebp
	invoke free_func,dictionary
	ret
unpack endp


;---------[ pack  - compression function ]-----------------------------\
; compresses the data, and returns:
;   EAX has the data pointer
;   EBX has the filesize
;----------------------/                 --------------\
;


;---------------------------------------------------
;Local variables structure (one for both subroutines)

ProcFrame       struc                      ;
FirstSym        dw ?                       ;First symbol
Link            dw ?                       ;Link
DictBound       dw ?                       ;Current dictionary limit
BitsPerSym      dw ?                       ;Bits in the output element
                                           ;(increases as the dictionary
                                           ;becomes full)
                                           ; 
NextInChar      db ?                       ;Next char in the input stream
field_9         db ?                       ;  something
field_A         db ?                       ;  other something
field_B         db ?                       ;  third one
                                           ;Resume: NextChar was DWORD ;-)
                                           ;
OutBufPos       dd ?                       ;Current output pointer
InBufRelPos     dd ?                       ;Current input pointer
RetEIP          dd ?                       ;return address lz_compress
                                           ;
                                           ;Parameters:
InBuf           dd ?                       ;Input buffer
OutBuf          dd ?                       ;Output buffer
SuxxSize        dd ?                       ;Size of data in the output buffer
Malloced        dd ?                       ;Temporary buffer for dictionary
ProcFrame       ends                       ;
                                           ;
;-------------------------------------------
;Dictionary record                         ;
;                                          ;
TableItem       struc                      ;
Sym             dw ?                       ;Symbol
NextSym         dw ?                       ;Next symbol
NextChar        db ?                       ;Next character in the chain
TableItem       ends                       ;
                                           ;
;=============================================================================
; Main function
;=============================================================================
lz_compress     proc near                  ;
                sub     eax, eax           ;
                push    eax                ;All fielst in the structure are
                push    eax                ;zeroed
                push    eax                ;
                push    eax                ;
                push    eax                ;
                mov     ebp, esp           ;EBP -> ProcFrame
                                           ;
                call    lz_init            ;Dictionary Reset
;                                          ;
                sub     eax, eax           ;
                inc     ah                 ;Symbol 100h = "dictionary reset"
                call    Save_And_Step      ;Dump it into the output
                                           ;
                call    Get_Byte           ;Get first byte
                                           ;
@@compess_cycle:                           ;AL = character
                sub     ah, ah             ;
                                           ;AX = symbol
@@get_chain:                               ;Searching for the unique string
                                           ;of characters
                mov     [ebp+ProcFrame.FirstSym], ax
                call    Get_Byte           ;
                jb      short lzc_exit     ;
                                           ;
                mov     [ebp+ProcFrame.NextInChar], al
                movzx   ebx, [ebp+ProcFrame.FirstSym]
                call    Search_Table       ;
                jnb     short @@get_chain  ;
                                           ;Chain found
                call    Set_Char_Link      ;
                                           ;Dump symbol into the output
                push    ebx                ;
                movzx   eax, [ebp+ProcFrame.FirstSym]
                call    Save_And_Step      ;
                pop     ebx                ;
                mov     al, [ebp+ProcFrame.NextInChar]
                cmp     bx, [ebp+ProcFrame.DictBound]
                jl      short @@compess_cycle
                                           ;
;--------->replaced<------------------------
;                cmp     [ebp+ProcFrame.BitsPerSym], 0Ch
                cmp     [ebp+ProcFrame.BitsPerSym], MAX_BITS  
                                           ;Index bits limit
;--------->end<-----------------------------
                jl      short next_bit     ;
                                           ;
                sub     eax, eax           ;
                inc     ah                 ; 100h - dictionary reset
                call    Save_And_Step      ;
                call    lz_init            ; and reset it
                mov     al, [ebp+ProcFrame.NextInChar]
                jmp     short @@compess_cycle
; 
                                           ;
next_bit:                                  ;
                inc     [ebp+ProcFrame.BitsPerSym]   ;Increase index
                shl     [ebp+ProcFrame.DictBound], 1 ;Increase dictionary
                jmp     short @@compess_cycle
; 
                                           ;
lzc_exit:                                  ;
                movzx   eax, [ebp+ProcFrame.FirstSym]
                call    Save_And_Step      ;
                mov     eax, 101h          ; 101h - end of chain
                call    Save_And_Step      ;
                xchg    eax, edi           ;
                sub     eax, [ebp+ProcFrame.OutBuf]  ;EAX = end-start = size
                add     esp, 14h           ;
                retn    10h                ;
lz_compress     endp                       ;
                                           ;
;-----------------------------------------------------------------------------
;Dinctionary reset
;-----------------------------------------------------------------------------
lz_init         proc near                  ;
                pusha                      ;
                mov     [ebp+ProcFrame.BitsPerSym], 9     
                                           ;9 bits ber each output symbol
                mov     [ebp+ProcFrame.DictBound], 200h   
                                           ;512 symbols in the dictionary
                sub     eax, eax           ;
                dec     eax                ;
                                           ;REset dictionary
                mov     ecx, COMPR_BUFFER_SIZE/2
                                           ;
                mov     edi, [ebp+ProcFrame.Malloced]
                rep stosw                 ;
                                           ;
                mov     [ebp+ProcFrame.Link], 102h ;First symbol
                                           ;
                                           ;(00-FF) - simpe symbols-characters
                                           ;          (elementary dictionary)
                                           ; 100    - dictionary reset
                                           ; 101    - end of data
                                           ; 102-... - free symbols
                                           ;
                popa                       ;
                retn                       ;
lz_init         endp                       ;
                                           ;
;------------------------------------------------------------------------------------
;Writes N bits (9-...) from the EAX to the output sream
;------------------------------------------------------------------------------------
Save_And_Step   proc near                  ;
                push    eax                ;
                mov     eax, [ebp+ProcFrame.OutBufPos] 
                                           ;EAX -> bit int the output buffer
                movzx   ecx, word ptr [ebp.ProcFrame.BitsPerSym] 
                                           ;ECX = how many bits to write
                add     [ebp+ProcFrame.OutBufPos], ecx 
                                           ;Step
                                           ;Calculate the bit offset
                mov     ecx, 8             ;
                sub     edx, edx           ;
                div     ecx                ; EDX = OutBufPos mod 8
                add     eax, [ebp+ProcFrame.OutBuf]
                xchg    eax, edi           ; EDI -> where to write
                pop     eax                ;
                                           ;
                mov     ecx, edx           ;
                sub     edx, edx           ;
                jcxz    save_3bytes        ; jump if on the byte's border
                                           ;
                shl     eax, cl            ;
                or      al, [edi]          ;
                                           ;
save_3bytes:                               ;
                stosw                      ;
                shr     eax, 10h           ;
                stosb                      ;
                retn                       ;
Save_And_Step   endp                       ;
                                           ;
;-----------------------------------------------------------------------------
;Read character from the input sream in AL
;-----------------------------------------------------------------------------
Get_Byte        proc near                  ;
                mov     esi, [ebp+ProcFrame.InBuf]       ; ESI -> InBuf
                mov     edi, [ebp+ProcFrame.InBufRelPos] ; EDI -> RelInBufPos
                cmp     edi, [ebp+ProcFrame.SuxxSize]    ; End already?
                jnb     short byaka                      ;
;                                                        ;
                mov     al, [esi+edi]                    ; Read
                inc     [ebp+ProcFrame.InBufRelPos]      ;
                clc                                      ;
                retn                                     ;
    byaka:                                               ;
                stc                                      ;
                retn                                     ;
Get_Byte        endp                                     ;
                                                         ;
;-----------------------------------------------------------------------------
;Dictionary search
;-----------------------------------------------------------------------------
Search_Table    proc near
                call    Calc_Sym_Pos                ;ESI -> TableItem
                sub     edi, edi                    ;EDI=0=success flag
                cmp     [esi+TableItem.Sym], 0FFFFh ;Do we have such symbol?
                jz      short not_found             ;
                                                    ;
                inc     edi                         ;set flag
                movzx   ebx, [esi+TableItem.Sym]    ;EBX=symbol
                                                    ;
scan_chain:                                         ;
                call    Calc_Sym_Pos                ;
                cmp     [esi+TableItem.NextChar], al  ;Is link exists?
                jnz     short next_char             ;
                                                    ;
                clc                                 ;
                movzx   eax, bx                     ;EAX=chain symbol
                retn                                ;
; 
                                                    ;
next_char:                                          ;
                cmp     [esi+TableItem.NextSym], 0FFFFh  ;End of the chain
                jz      short not_found             ;
                movzx   ebx, [esi+TableItem.NextSym] ;EBX=next symbol
                jmp     short scan_chain            ;
; 
                                                    ;
not_found:                                          ;
                stc                                 ;No such chain
                retn                                ;
Search_Table    endp                                ;
                                                    ;
;-----------------------------------------------------------------------------
;Calculate TableItem address in the dictionary using symbol in EBX
;-----------------------------------------------------------------------------
Calc_Sym_Pos    proc near                           ;
                lea     esi, [ebx+ebx*4]            ; ESI = EBX*sizeof(TableItem)
                add     esi, [ebp+ProcFrame.Malloced] ;ESI += buffer offset
                retn                                ;
Calc_Sym_Pos    endp                                ;
                                                    ;
;-----------------------------------------------------------------------------
;Link character and symbol in the dictionary
;-----------------------------------------------------------------------------
Set_Char_Link   proc near                           ;
                movzx   ebx, [ebp+ProcFrame.Link]   ;
                cmp     edi, 0                      ; EDI=Search_Table status
                jz      short set_link              ;
                mov     [esi.TableItem.NextSym], bx ;
                jmp     short test_sym              ;
; 
                                                    ;
set_link:                                           ;
                mov     [esi.TableItem.Sym], bx     ;Write symbol
                                                    ;
test_sym:                                           ;
;------>replaced<------                             ;
;               cmp     bx, 1000h                   ;
                cmp     bx, BITS_DEPENDED_BUFF_SIZE ;Last symbol in the dictionary?
;------>end<-----------                             ;
                jz      short scl_exit              ;
                                                    ;
                call    Calc_Sym_Pos                ; Mark as unused (FFFF)
                mov     word ptr [esi.TableItem.Sym], 0FFFFh
                mov     word ptr [esi.TableItem.NextSym], 0FFFFh
                mov     [esi.TableItem.NextChar], al
                inc     [ebp+ProcFrame.Link]        ;
                                                    ;
scl_exit:                                           ;
                retn                                ;
Set_Char_Link   endp                                ;
                                                    ;
						    
pack proc uses ecx edx esi edi DataToPack,DataToPackSize  
	local dictionary,outbuf,packedsiz	
	.if !DataToPackSize
		xor ebx,ebx
		return 0
	.endif
	invoke malloc_func,COMPR_BUFFER_SIZE
	mov dictionary,eax
	invoke malloc_func,DataToPackSize
	mov outbuf,eax
	push ebp
	pushi dictionary,DataToPackSize,outbuf,DataToPack
	call lz_compress
	pop ebp
	mov packedsiz,eax
	invoke free_func,dictionary
	invoke realloc_func,outbuf,packedsiz ; eax now is the new outbuf
	; mov outbuf,eax ; unnecessary
	mov ebx,packedsiz
	ret
pack endp ;-------------------------------------------/
;----------------------------------------------------------------------/

;=======/




@IFUNC_PROTO0 typedef proto
@IFUNC_PROTO1 typedef proto :DWORD
@IFUNC_PROTO2 typedef proto :DWORD,:DWORD
@IFUNC_PROTO3 typedef proto :DWORD,:DWORD,:DWORD
@IFUNC_PROTO4 typedef proto :DWORD,:DWORD,:DWORD,:DWORD
@IFUNC_PROTO5 typedef proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
@IFUNC_PROTO6 typedef proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
@IFUNC_PROTO7 typedef proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
@IFUNC_PROTO8 typedef proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
@IFUNC_PROTO9 typedef proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
@IFUNC_PROTO10 typedef proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

@IFUNC_PFUNC0 typedef ptr @IFUNC_PROTO0
@IFUNC_PFUNC1 typedef ptr @IFUNC_PROTO1
@IFUNC_PFUNC2 typedef ptr @IFUNC_PROTO2
@IFUNC_PFUNC3 typedef ptr @IFUNC_PROTO3
@IFUNC_PFUNC4 typedef ptr @IFUNC_PROTO4
@IFUNC_PFUNC5 typedef ptr @IFUNC_PROTO5
@IFUNC_PFUNC6 typedef ptr @IFUNC_PROTO6
@IFUNC_PFUNC7 typedef ptr @IFUNC_PROTO7
@IFUNC_PFUNC8 typedef ptr @IFUNC_PROTO8
@IFUNC_PFUNC9 typedef ptr @IFUNC_PROTO9
@IFUNC_PFUNC10 typedef ptr @IFUNC_PROTO10

IFUNC macro args:VARARG
	local ArgCount,arg1,IsSpecial,intHasColon,intNumColons
	local strTypeArg
	
	
	ifndef @IFUNC_NumSpecialProtos
		@IFUNC_NumSpecialProtos = 0
	endif
	
	@IFUNC_NumSpecialProtos = @IFUNC_NumSpecialProtos + 1
	
	IsSpecial = 0
	ArgCount = 0
	intNumColons = 0
	
	for arg1,<args>
		ArgCount = ArgCount + 1
		intHasColon INSTR <arg1>,<:>
		if intHasColon
			intNumColons = intNumColons + 1
			strTypeArg SUBSTR <arg1>,intHasColon+1
			ifdif strTypeArg,<DWORD>
				ifdif strTypeArg,<real4>
					IsSpecial=1
				endif
			endif
		endif
	endm
	
	
	if IsSpecial
		if intNumColons eq ArgCount
			@CatStr(<@IFUNC_$SP>,%@IFUNC_NumSpecialProtos) typedef proto args
			@CatStr(<@IFUNC_$PSP>,%@IFUNC_NumSpecialProtos) typedef ptr @CatStr(<@IFUNC_$SP>,%@IFUNC_NumSpecialProtos)
			exitm <@CatStr(<@IFUNC_$PSP>,%@IFUNC_NumSpecialProtos) ?>
		else
			strTypeArg CATSTR <@IFUNC_$SP>,%@IFUNC_NumSpecialProtos,< typedef proto >
			for arg1,<args>
				ArgCount = ArgCount - 1
				intHasColon INSTR <arg1>,<:>
				if intHasColon
					strTypeArg CATSTR strTypeArg,<arg1>
				else
					strTypeArg CATSTR strTypeArg,<:DWORD>
				endif
				if ArgCount
					strTypeArg CATSTR strTypeArg,<,>
				endif
			endm
			strTypeArg
			@CatStr(<@IFUNC_$PSP>,%@IFUNC_NumSpecialProtos) typedef ptr @CatStr(<@IFUNC_$SP>,%@IFUNC_NumSpecialProtos)
			exitm <@CatStr(<@IFUNC_$PSP>,%@IFUNC_NumSpecialProtos) ?>		
		endif
	else
		exitm <@CatStr(<@IFUNC_PFUNC>,%ArgCount) ?>
		
	endif
	
endm

;=====<< strcpy >>===\
strcpy proc uses eax esi edi pDest,pSrc
	mov esi,pSrc
	mov edi,pDest
	@@:
	mov al,[esi]
	mov [edi],al
	inc esi
	inc edi
	or al,al
	jnz @B
	
	ret
strcpy endp
;=======/
;=====<< strcat >>===\
strcat proc uses eax esi edi pDest,pSrc
	mov edi,pDest
	.while byte ptr[edi]
		inc edi
	.endw
	
	mov esi,pSrc
	
	@@:
	mov al,[esi]
	mov [edi],al
	inc esi
	inc edi
	or al,al
	jnz @B
	
	ret
strcat endp
;=======/
